const AppDisplay = imports.ui.appDisplay;
const Main = imports.ui.main;
const Search = imports.ui.search;

let appDisplayAppIconInit;
let appDisplayFolderIconInit;
let searchListSearchResultInit;
let searchProviderInfoSetMoreCount;

function appIcon_init(app, iconParams)
{
    appDisplayAppIconInit.apply(this, [app, iconParams]);

    this.icon.label.add_style_class_name('label-shadow');
}

function folderIcon_init(id, path, parentView)
{
    appDisplayFolderIconInit.apply(this, [id, path, parentView]);

    this.icon.label.add_style_class_name('label-shadow');
}

function listSearchResult_init(provider, metaInfo, resultsView)
{
    searchListSearchResultInit.apply(this, [provider, metaInfo, resultsView]);

    this._descriptionLabel.add_style_class_name('label-white');
    this.actor.add_style_class_name('label-shadow');
}

function providerInfo_setMoreCount(count)
{
    searchProviderInfoSetMoreCount.apply(this, [count]);

    this._content.add_style_class_name('label-shadow');
}

function redisplay()
{
    //Main.overview.viewSelector.appDisplay._views[AppDisplay.Views.FREQUENT].view._grid.destroyAll();
    //Main.overview.viewSelector.appDisplay._views[AppDisplay.Views.ALL].view._grid.destroyAll();
    Main.overview.viewSelector.appDisplay._views[AppDisplay.Views.FREQUENT].view._redisplay();
    Main.overview.viewSelector.appDisplay._views[AppDisplay.Views.ALL].view._redisplay();
}

function init()
{
}

function enable()
{
    appDisplayAppIconInit = AppDisplay.AppIcon.prototype._init;
    AppDisplay.AppIcon.prototype._init = appIcon_init;
    appDisplayFolderIconInit = AppDisplay.FolderIcon.prototype._init;
    AppDisplay.FolderIcon.prototype._init = folderIcon_init;
    searchListSearchResultInit = Search.ListSearchResult.prototype._init;
    Search.ListSearchResult.prototype._init = listSearchResult_init;
    searchProviderInfoSetMoreCount = Search.ProviderInfo.prototype.setMoreCount;
    Search.ProviderInfo.prototype.setMoreCount = providerInfo_setMoreCount;

    redisplay();
}

function disable()
{
    AppDisplay.AppIcon.prototype._init = appDisplayAppIconInit;
    AppDisplay.FolderIcon.prototype._init = appDisplayFolderIconInit;
    Search.ListSearchResult.prototype._init = searchListSearchResultInit;
    Search.ProviderInfo.prototype.setMoreCount = searchProviderInfoSetMoreCount;

    redisplay();
}
